/*
PHP Based iTunes Library Browser
Copyright (C) 2007  Jason Barrie Morley

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/

// Define the variables.
var IsFocused = 0;
var IsActive = 0;
var classes = new Array();

// Functions.

function Filter(string) {
    // Work out if the box is empty.
    if (string.length > 0) {
        IsActive = true;
    } else {
        IsActive = false;
    }
}

function ChangeFilter(searchbox) {
    var input = document.getElementById(searchbox);
    Filter(input.value);
}

function ClearFilter(searchbox) {
    var input = document.getElementById(searchbox);
    if (IsActive) {
        input.value = "Search";
        input.style.color = "gray";
        IsFocused = false;
        Filter("");
    } else {
        // Do nothing.
    }
}

function ChangeFocus(searchbox) {
    var input = document.getElementById(searchbox);
    if (!IsFocused && !IsActive && (input.style.color != "#000" && input.style.color != "rgb(0, 0, 0)")) {
        input.style.color = "black";
        input.value = "";
        IsFocused = true;
    } else if (IsFocused && !IsActive) {
        input.style.color = "gray";
        input.value = "Search";
        IsFocused = false;
    }
}

function TableHighlighter(id, classname) {
    var table = document.getElementById(id);
    var rows = table.getElementsByTagName("tr");

    for(var i = 0; i < rows.length; i++) {
        var ths = rows[i].getElementsByTagName("th");
        if (ths.length < 1) {
            rows[i].id = i;
            classes[i] = rows[i].className;
            rows[i].onmousemove = function()
                                    {
                                    this.className = classname;
                                    };
            rows[i].onmouseout = function()
                                    {
                                    this.style.backgroundColor = "";
                                    this.className = classes[this.id];
                                    };
            rows[i].style.cursor = "pointer";
        }
    }

}
