<?php

    /*
    PHP Table Rendering Library for MySQL
    Copyright (C) 2007  Jason Barrie Morley
    
    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2
    of the License, or (at your option) any later version.
    
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
    
    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
    */
    
    function RenderTable($table, $conditions, $columns, $size, $sort = 1, $order = 0, $rowclass = false, $rowlink = false, $exists = false, $clear = false) {
    
        // Infered Settings.
        $offset = 0;
        $sizePlus = $size + 1;
        $search = "";
    
        // Override any settings by inspecting the $_GET[] variable.
        if ($_GET['offset']) { $offset = $_GET['offset']; }
        if ($_GET['column']) { $sort = $_GET['column']; }
        if ($_GET['order']) { $order = $_GET['order']; }
        if ($_GET['search']) { $search = $_GET['search']; }
    
        // Construct the SQL Query.
    
        // Sort direction.
        $direction = "";
        if ($order == 0) {
            $direction = "ASC";
        } else {
            $direction = "DESC";
        }
    
        // Table fields.
        $fields = "";
        $number = count($columns);
        $count = 1;
        foreach ($columns as $key=>$value) {
            $fields .= $key;
            if ($count != $number) {
                $fields .= ",";
            }
            $count++;
        }
    
        // Try handling searching.
        $searchString = "1";
        if ($search != "") {
            // $searchString = "WHERE MATCH (name) AGAINST ('+$search' IN BOOLEAN MODE)"; // Boolean Search.
            // $searchString = "WHERE MATCH (name) AGAINST ('$search')"; // Fulltext Index Match.
            $count = 0;
            foreach ($columns as $key=>$value) {
                if ($count == 0) {
                    $searchString = $key." REGEXP '".$search."'";
                } else {
                    $searchString .= " OR ".$key." REGEXP '".$search."'";
                }
                $count++;
            }
        }
    
        $conditions = SqlAnd(array($conditions, $searchString));
    
        // Join the conditions and the table.
        $table = $table." WHERE (".$conditions.")";
    
        if ($exists !== false) {
            $table .= " AND EXISTS (".$exists.")";
        }
    
        $order_key; $idx = 1;
        foreach ($columns as $key=>$array) {
            $order_key = $key;
        if ($idx == $sort) { break; }
        $idx++;
        }
    
    
        // Actual queries.
        $sql = "SELECT ".$fields." FROM ".$table." ORDER BY ".$order_key." ".$direction." LIMIT ".$offset.",".$sizePlus;
        $sqlCount = "SELECT COUNT(*) FROM ".$table." ORDER BY ".$order_key." ".$direction;
    
        // Run the count query.
        $result = mysql_query($sqlCount);
        $count = mysql_result($result, 0, "COUNT(*)");
    
    
        // Run the query.
        $result = mysql_query($sql);
    
        // Debug.
        // print $sql."<br/>"; if ($result === false) { print mysql_error(); }
    
        $resultSize = mysql_num_rows($result);
    
        // Print the navigation controls.
        print '<div id="controls">';
        print '<form method="get">';
    
        // Print the forward and back links.
    
        if ($offset > 0) {
            $newOffset = $offset - $size;
            if ($newOffset < 0) { $newOffset = 0; }
            
            # First Link.
            $link = GetLink(array("offset" => "0"));
            print '<a href="'.$link.'">&lt;&lt;</a>';
    
            # Previous Link.
            $link = GetLink(array("offset" => $newOffset));
            print '<a href="'.$link.'">&lt;</a>';
            // print '<a href="'.$link.'">Previous '.$size.'</a>'; // Old format.
    
        }
        
        # Print the page lists.
        $pageStart = 0;
        $pageNo = 1;
        while ($pageStart+$size < $count) {
            $pageNo++;
            $pageStart += $size;
        }
        
        $page = (int)($offset / $size);
        $page++;
        print $page." of ".$pageNo;
    
    
        if ($resultSize > $size) {
            $newOffset = $offset + $size;
    
            # Next Link.
            $link = GetLink(array("offset" => $newOffset));
            print '<a href="'.$link.'">&gt;</a>';
    
            $resultSize = $size;
    
            # Last Link.
            $link = GetLink(array("offset" => $pageStart));
            print '<a href="'.$link.'">&gt;&gt;</a>';
    
        }
        
        // Print the number of items.
        print "<span id='count'>".$count." items</span>";
    
    
        // Print the search box.
    
        // Print all the current get parameters as hidden values to make sure they are passed back.
        foreach ($_GET as $key=>$value) {
            if ($key != "search" && $key != "offset") {
                print '<input type="hidden" name="'.$key.'" value="'.$value.'">';
            }
        }
    
        if ($search != "") {
            print '<input style="color: #000;" type="text" name="search" id="filter" onKeyUp="ChangeFilter(\'filter\');" value="'.$search.'" onBlur="ChangeFocus(\'filter\');" onFocus="ChangeFocus(\'filter\');">';
        } else {
            print '<input style="color: grey;" type="text" name="search" id="filter" onKeyUp="ChangeFilter(\'filter\');" value="Search" onBlur="ChangeFocus(\'filter\');" onFocus="ChangeFocus(\'filter\');">';
        }
    
        $link = GetLink(array(
                              "offset" => "",
                              "search" => "",
                              ));
        if ($clear === false) {
            print '<span id="clear"><a href="'.$link.'">Clear</a></span>';
        } else {
            print '<span id="clear"><a href="'.$link.'">'.$clear.'</a></span>';
        }
    
        print '</form>';
    
        print '</div>';
    
        // Print the table.
        print "<div class='tablebox'>\n";
        print "<table id='linktable' class='horizontal'>\n";
    
        print "<tr>\n";
        $count = 1;
        foreach ($columns as $key=>$array) {
            
        if ($count == 1) {
            if ($count == $sort) {
                print "<th class='leftsort'>";
            } else {
                print "<th class='left'>";
            }
        } else if ($count == sizeof($columns)) {
            if ($count == $sort) {
                print "<th class='rightsort'>";
            } else {
                print "<th class='right'>";
            }
        } else {
            if ($count == $sort) {
                print "<th class='sort'>";
            } else {
                print "<th>";
            }
        }
    
            $value = $array[0];
    
            $orderString = "";
            if ($count == $sort) {
                $orderString = " &uarr;";
                if ($order == 0) {
                    $link = GetLink(array(
                                          "column" => $count,
                                          "order" => 1,
                                          "offset" => ""
                                          ));
                    print "<a href='".$link."'>".$value."</a> &darr;";
                } else {
                    $link = GetLink(array(
                                          "column" => $count,
                                          "order" => 0,
                                          "offset" => ""
                                          ));
                    print "<a href='".$link."'>".$value."</a> &uarr;";
                }
            } else {
                $link = GetLink(array(
                                      "column" => $count,
                                      "offset" => ""
                                      ));
                print "<a href='".$link."'>".$value."</a>";
            }
    
            print "</th>";
            $count++;
        }
        print "</tr>\n";
    
        for($i = 0; $i < $resultSize; $i++) {
    
            // Get the various fields into an associative array.
            $fields = array();
    
            foreach ($columns as $key=>$array) {
    
                $value = $array[0];
                $string = mysql_result($result, $i, $key);
                $fields[$key] = $string;
    
            }
    
            // Call out to a function to determine a custom row class if one exists.
    
            $class = "";
            $even = $i % 2 == 0 ? true : false;
    
            if ($rowclass !== false) {
                $class = call_user_func($rowclass, $fields, $even);
            }
    
            // If no custom class is used, still alternate the colour.
            if ($class == "" && $even) { $class = " class='even'"; }
            else { $class = " class='".$class."'"; }
    
            // Handle any explicit link for the row.
            $link = "";
            if ($rowlink !== false) {
                $link = call_user_func($rowlink, $fields);
                $link = " onClick='window.location = \"".$link."\";'";
            }
    
            // Start the row.
            print "<tr".$class.$link.">\n";
    
            // Next, print the fields, passing them to any user function if required.
    
        $count = 1;
            foreach ($columns as $key=>$array) {
    
                $string = "";
                if (sizeof($array) > 1) {
                    $function = $array[1];
                    $string = call_user_func($function, $fields[$key], $fields);
                } else {
                    $string = $fields[$key];
                }
    
            if ($count == 1) {
                print "<td class='left'>".$string."</td>\n";
            } else if ($count == sizeof($columns)) {
                print "<td class='right'>".$string."</td>\n";
            } else {
                print "<td>".$string."</td>\n";
            }
            $count++;
    
            }
    
    
            print "</tr>\n";
    
        }
    
        print "</table>\n";
        print "</div>\n";
    
    }
    
    // ORs a collection of key-value pairs.
    function SqlOrPairs($fields) {
    
        $query = "";
        foreach ($fields as $value) {
            if ($query != "") {
                $query .= " OR ";
            }
            $query .= $value[0]." = '".$value[1]."'";
        }
        return $query;
    
    }
    
    // ANDs a collection of key-value pairs.
    function SqlAndPairs($fields) {
    
        $query = "";
        foreach ($fields as $value) {
            if ($query != "") {
                $query .= " AND ";
            }
            $query .= $value[0]." = '".$value[1]."'";
        }
        return $query;
    
    }
    
    // ORs a collection of statements.
    function SqlOr($fields) {
    
        $query = "";
        foreach ($fields as $value) {
            if ($query != "") {
                $query .= " OR ";
            }
            $query .= "( ".$value." )";
        }
        return $query;
    
    }
    
    // ANDs a collection of statements.
    function SqlAnd($fields) {
    
        $query = "";
        foreach ($fields as $value) {
            if ($query != "") {
                $query .= " AND ";
            }
            $query .= "( ".$value." )";
        }
        return $query;
    
    }
    
    function GetLink($parameters) {
        
        $return = "?";
    
        foreach ($_GET as $key=>$value) {
            if (!array_key_exists($key, $parameters)) {
                $parameters[$key] = $value;
            }
        }
    
        // Actually get the string.
        $count = 0;
        foreach ($parameters as $key=>$value) {
            if ($count == 0) {
                if ($value != "") {
                    $return .= $key."=".$value;
                    $count++;
                }
            } else {
                if ($value != "") {
                    $return .= "&".$key."=".$value;
                }
            }
    
        }
    
        return $return;
    
    }

?>